/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Widget sample;
static GC gc;
static Colormap colormap;
static unsigned long pixel;
static unsigned long red = 0, green = 0, blue = 0;

/* XP[̃R[obN */
static void ChangeColorCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmScaleCallbackStruct *cb = (XmScaleCallbackStruct *)call_data;
    XColor color;

    /* VlZbg */
    switch ((int)client_data) {  /* ǂ̃XP[̒lς̂ */
        case 0: red   = cb->value; break;  /* Ԃ̃XP[ */
        case 1: green = cb->value; break;  /* ΂̃XP[ */
        case 2: blue  = cb->value; break;  /* ̃XP[ */
    }
    /* VF̏Zbg */
    color.pixel = pixel;  /* ύXsNZl (LJ[Z) */
    color.red   = red   * 256;  /* RGB l͈̔͂ 0 - 65535D */ 
    color.green = green * 256;  /* XP[͈̔͂ 0 - 255 Ȃ̂ */
    color.blue  = blue  * 256;  /* 256 { RGB lƂėp */
    color.flags = DoRed | DoGreen | DoBlue;  /* RGB vfύX */

    /* F̒lŐFt */
    if (XStoreColor(XtDisplay(w), colormap, &color) == 0) {
        fprintf(stderr, "Cannot allocate the new color\n");
        exit(1);
    }

    /* F̃sNZlCTvEEBWFbg̔wiɐݒ */
    XtVaSetValues(sample, XmNbackground, color.pixel, NULL);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, control, scales[3];
    Arg al[20];
    int ac;
    int i;
    char wname[10];
    unsigned long plane;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* Xc[Lbg (fBXvCI[v) */
    toplevel = XtAppInitialize(&app_context, "Changecolor", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* FTv\EBWFbg */
    ac = 0;
    sample = XmCreateLabel(panel, "sample", al, ac);
    XtManageChild(sample);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    for (i = 0; i < 3; i++) {
        ac = 0;
        sprintf(wname, "scale%d", i);
        scales[i] = XmCreateScale(control, wname, al, ac);
        XtAddCallback(scales[i], XmNdragCallback, ChangeColorCB, i);
        XtAddCallback(scales[i], XmNvalueChangedCallback, ChangeColorCB, i);
    }
    XtManageChildren(scales, 3);

    /* ftHg̃J[}bv𓾂 */
    colormap = DefaultColormapOfScreen(XtScreen(sample));
    /* 1̃J[ZL */
    if (XAllocColorCells(XtDisplay(sample), colormap,
                         False, &plane, 0, &pixel, 1) == 0) {
        fprintf(stderr, "Cannot allocate color cell.\n");
        exit(1);
    }

    XtRealizeWidget(toplevel); /* ŃEBhE */

    /* OtBbNEReLXg쐬ݒ */
    gc = XCreateGC(XtDisplay(sample), XtWindow(sample), NULL, NULL);

    /* ̐Fɐݒ肵Ă */
    XtVaSetValues(sample,
                  XmNbackground, BlackPixelOfScreen(XtScreen(sample)), NULL);

    XtAppMainLoop(app_context);
}
