/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL  (3 * 1000)

typedef struct _WmStateHint {
    unsigned long state;
    Window        icon;
} WmStateHint;

static void WithdrawCB(), Withdraw2Icon(), Icon2Normal();
static void IconifyCB(), Icon2Withdraw(), Withdraw2Normal();
static void MappedEH(), StateEH();

main(argc, argv)
    int argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, withdraw, iconify;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Wmstate", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* (1) gbvx̃EBhE}bv܂ő҂ */
    XtAddEventHandler(toplevel, StructureNotifyMask, False, MappedEH, NULL);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (2) [P ->  -> ʏ] {^ */
    ac = 0;
    withdraw = XmCreatePushButton(panel, "withdraw", al, ac);
    XtManageChild(withdraw);
    XtAddCallback(withdraw, XmNactivateCallback, WithdrawCB, toplevel);

    /* (3) [ -> P -> ʏ] {^ */
    ac = 0;
    iconify = XmCreatePushButton(panel, "iconify", al, ac);
    XtManageChild(iconify);
    XtAddCallback(iconify, XmNactivateCallback, IconifyCB, toplevel);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [P ->  -> ʏ] {^ꂽƂ̃R[obN */
static void WithdrawCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (5) }bv Withdrawn Ԃɂ */
    XtUnmapWidget(toplevel);

    /* (6) 3 b Withdraw2Icon() Ăяo */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Withdraw2Icon, toplevel);
}

/* (7) WithdrawCB()  3 bɌĂяo */
static void Withdraw2Icon(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (8) Withdrawn ԂACRԂɕύX */
    XtVaSetValues(toplevel, XmNinitialState, IconicState, NULL);
    XtMapWidget(toplevel);

    /* (9) 3 b Icon2Normal() Ăяo */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Icon2Normal, toplevel);
}

/* (10) Withdraw2Icon()  3 bɌĂяo */
static void Icon2Normal(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;

    /* (11) ACRԂ畁ʂ̏Ԃɖ߂ */
    XtMapWidget(toplevel);
}

/* (12) [ -> P -> ʏ] {^ꂽƂ̃R[obN */
static void IconifyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (13) ACRԂɂ */
    XIconifyWindow(XtDisplay(toplevel), XtWindow(toplevel),
                   XScreenNumberOfScreen(XtScreen(toplevel)));

    /* (14) 3 b Icon2Withdraw() Ăяo */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Icon2Withdraw, toplevel);
}

/* (15) IconifyCB()  3 bɌĂяo */
static void Icon2Withdraw(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;
    XUnmapEvent unmap;

    /* (16) ACRԂ Withdrawn ԂɕύX */
    /* Unmap ̃Cxg\̂ */
    unmap.type = UnmapNotify;
    unmap.display = XtDisplay(toplevel);
    unmap.event = RootWindowOfScreen(XtScreen(toplevel));
    unmap.window = XtWindow(toplevel);
    unmap.from_configure = False;
    /* ̃Cxg[gEEBhEĂɑ */
    XSendEvent(XtDisplay(toplevel), RootWindowOfScreen(XtScreen(toplevel)),
              False, SubstructureRedirectMask | SubstructureNotifyMask, &unmap);

    /* (17) 3 b Withdraw2Normal() Ăяo */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Withdraw2Normal, toplevel);
}

/* (18) Icon2Withdraw()  3 bɌĂяo */
static void Withdraw2Normal(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;

    /* (19) Withdraw Ԃ畁ʂ̏Ԃɖ߂ */
    XtVaSetValues(toplevel, XmNinitialState, NormalState, NULL);
    XtMapWidget(toplevel);
}

/* (20) ŏɃgbvx̃EBhE}bvꂽƂɌĂяo */
static void MappedEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    if (event->type == MapNotify) {
        /* (21) gbvx̃EBhẼvpeBωm */
        XtAddEventHandler(w, PropertyChangeMask, False, StateEH, NULL);
        XtRemoveEventHandler(w, StructureNotifyMask, False, MappedEH, NULL);
    }
}

/* (22) gbvx̃EBhẼvpeBωƂɌĂяo */
static void StateEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    Atom xa_wm_state, actual_type;
    int actual_format;
    unsigned long nitems, left;
    WmStateHint *state_hint;

    /* (23) "WM_STATE" ̃Ag𐶐 */
    xa_wm_state = XmInternAtom(XtDisplay(w), "WM_STATE", False);

    /* (24) gbvx̃EBhE "WM_STATE" vpeBǂ */
    if (XGetWindowProperty(XtDisplay(w), XtWindow(w),
                           xa_wm_state, 0, 2, False, xa_wm_state,
                           &actual_type, &actual_format, &nitems, &left,
                           (unsigned char **)&state_hint)
                == Success && actual_type == xa_wm_state && nitems == 2) {

        /* (25) "WM_STATE" ̒lŌ݂̃EBhEԂ𔻒f */
        switch (state_hint->state) {
        case WithdrawnState:
                printf("Withdrawn State\n");
                break;
        case NormalState:
                printf("Normal State\n");
                break;
        case IconicState:
                printf("Iconic State\n");
                break;
        default:
                printf("Unknown State\n");
                break;
        }
    }
    else {
        fprintf(stderr, "Couldn't get window state.\n");
    }
}
